
import java.util.Scanner;

public class Fibonacci {
        
    static long fibonacciIter(int n) {
        if(n==1 || n==2) return 1;

        long f1=1;
        long f2=1;
        
        for(int i=3; i<=n; i++) {
            long tmp=f2;
            f2=f1+f2;
            f1=tmp;
        }
        
        return f2;
    }
    
    static long fibonacciDynamic(int n) {
        if(n==1 || n==2) return 1;

        long F[]=new long[n+1];
        
        F[1]=1;
        F[2]=1;
        
        for(int i=3; i<=n; i++) {
            F[i]=F[i-2]+F[i-1];
        }
        
        return F[n];
    }
    
    static long fibonacci(int n) {
        if(n==1 || n==2) return 1;
        else return fibonacci(n-2)+fibonacci(n-1);
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        System.out.println("Podaj liczbe:");
        int n = sc.nextInt();
        
        
        System.out.println("Wynik:"+fibonacci(n));
        
        System.out.println("Wynik iter:"+fibonacciDynamic(n));

        System.out.println("Wynik iter:"+fibonacciIter(n));
    }
    
}
